﻿:::::::::::::::::::::::::::::::::::::::::
::	file: Arma3Tools_diag_retail.bat
::	======
::	Author: Tom_48_97 - twitter: @tom_48_97 
::  (c) 2014 Bohemia Interactive
::	Description: 
::	Note: 
::	Wiki:
:::::::::::::::::::::::::::::::::::::::::
@echo off
cls
set "output=%temp%\BIStudio\Arma3Tools_diag_retail.rpt"
if not exist %temp%\BIStudio mkdir %temp%\BIStudio
echo /*-------------------------------------------------------------------- > %output% 
echo 	                  Arma 3 Tools Diagnostic 							>> %output% 
echo --------------------------------------------------------------------*/ >> %output% 
echo /*--------------------------------------------------------------------
echo 	                  Arma 3 Tools Diagnostic
echo --------------------------------------------------------------------*/
echo.
echo this script will just search for Arma 3 and P Drive key into 
echo your Windows registry and store results into results.txt
echo.
echo do you want to proceeed?
choice /c:yn
if %errorlevel% EQU 2 (set ERRCODE=1 & goto:error)
echo.
if not exist "%~dp0\AddonBuilder.exe" (set ERRCODE=2 & goto:error)
if "%~dp0" EQU "P:\" (set ERRCODE=4 & goto:error)
::-----------------------------------
call:BeginOfSection System informations
echo User="%USERNAME%" 1>> %output%
FOR /F "tokens=3 delims= " %%G in ('reg query "hklm\system\controlset001\control\nls\language" /v Installlanguage') DO (
	IF [%%G] EQU [0409] (
		echo language="ENGLISH" 1>> %output%
	) ELSE (
		ECHO language="%%G" 1>> %output%
	)
)
for /f "tokens=1-9" %%a in ('"systeminfo | find /i "OS Name""') do (echo OSName="%%e"  1>> %output%)
call:getOSVersion "5.1." "Windows XP" 1>> %output%
call:getOSVersion "5.0." "Windows 2000" 1>> %output%
call:getOSVersion "5.2." "Server 2003" 1>> %output%
call:getOSVersion "6.0." "Vista || Server 2008" 1>> %output%
call:getOSVersion "6.1." "Windows 7 || Server 2008R2" 1>> %output%
call:getOSVersion "6.2." "Windows 8 || Server 2012" 1>> %output%
call:getOSVersion "6.3." "Windows 8.1 || Server 2012R2" 1>> %output%
:EndOfSysteminformations
call:EndOfSection
::-----------------------------------
call:BeginOfSection Scan Arma 3 Tools folder
echo Working dir = "%~dp0" 1>> %output%
@cd "%~dp0"
if not exist P: (echo "!(p:)" 1>> %output%) else (echo "P:" 1>> %output%)
pushd %~dp0
dir /o /q /c /w /x 1>> %output%
echo steamapps steam_appid.txt 1>> %output%
if not exist steam_appid.txt (ERRCODE=3 & goto:error) else (type steam_appid.txt 1>> %output%)
echo. 1>> %output%
echo size	date		time		name 1>> %output%
forfiles /P . /m *.bat /c "cmd /c echo @fsize0x09@fdate0x09@ftime0x09@fname 1>> %output%"
popd
call:EndOfSection

::-----------------------------------
call:BeginOfSection Looking for HKCR entries
call:search_HKCR sqm
call:search_HKCR xml
call:search_HKCR sqf
call:search_HKCR sqs
call:search_HKCR ext
call:search_HKCR hpp
call:search_HKCR cpp
call:search_HKCR paa
call:search_HKCR p3d
call:search_HKCR pac
call:search_HKCR tv4p
call:search_HKCR xv4p
call:search_HKCR pew
call:search_HKCR wrp
call:search_HKCR pbo
call:EndOfSection

::-----------------------------------
call:BeginOfSection Looking for Arma 3 node
For /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKLM\SOFTWARE\Wow6432Node\Bohemia Interactive\Arma 3" /v "MAIN"') Do 			(set v64_path_a3="%%B") 
if defined v64_path_a3 (echo v64_path_a3=%v64_path_a3% 1>> %output%) else (echo v64_path_a3="NULL" 1>> %output%)
For /F "Tokens=2* skip=2" %%C In ('REG QUERY "HKLM\SOFTWARE\Bohemia Interactive\Arma 3" /v "MAIN"') Do 						(set v32_path_a3="%%D")
if defined v32_path_a3 (echo v32_path_a3=%v32_path_a3% 1>> %output%) else (echo v32_path_a3="NULL" 1>> %output%)
for /F "tokens=2* delims=	 " %%I IN ('REG QUERY "HKLM\SOFTWARE\Wow6432Node\Bohemia Interactive\Arma 3" /v "MAIN"') do 	(set uac_PATH_a3="%%J") 
if defined uac_PATH_a3 (echo uac_PATH_a3=%uac_PATH_a3% 1>> %output%) else (echo uac_PATH_a3="NULL" 1>> %output%)
for /F "tokens=2* delims=	 " %%K IN ('REG QUERY "HKLM\SOFTWARE\Bohemia Interactive\Arma 3" /v "MAIN"') DO 				(set std_PATH_a3="%%L") 
if defined std_PATH_a3 (echo std_PATH_a3=%std_PATH_a3% 1>> %output%) else (echo std_PATH_a3="NULL" 1>> %output%)
for /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKLM\SOFTWARE\Wow6432Node\Valve\Steam" /v "InstallPath" 2^>nul') do 			(set steam_v64_path="%%B\steamapps\common\Arma 3") 
if defined steam_v64_path (echo steam_v64_path=%steam_v64_path% 1>> %output%) else (echo steam_v64_path="NULL" 1>> %output%)
for /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKLM\SOFTWARE\Valve\Steam" /v "InstallPath" 2^>nul') do 						(set steam_v32_path="%%B\steamapps\common\Arma 3")
if defined steam_v32_path (echo steam_v32_path=%steam_v32_path% 1>> %output%) else (echo steam_v32_path="NULL" 1>> %output%)
call:EndOfSection

::-----------------------------------
call:BeginOfSection Looking for Arma 3 tools node
REG Query "HKEY_CURRENT_USER\Software\bohemia interactive" /S 1>> %output%
REG Query "HKEY_CURRENT_USER\Software\Bohemia Interactive Studio" /S 1>> %output%
rem REG Query "HKCU\Software" /F "bohemia interactive" /S 1>> %output%
call:EndOfSection

::-----------------------------------
call:BeginOfSection User Settings
if not exist settings.ini (echo settings.ini is missing 1>> %output% ) else (type settings.ini 1>> %output% )
call:EndOfSection

::-----------------------------------
call:BeginOfSection Run scripts with -DEBUG
echo You must hit [SPACE] bar after each timer (2 seconds) to proceed to next stage
pushd %~dp0
timeout /t 2 /noBreak
echo. 1>> %output%
echo ------------------------ 1>> %output%
echo ☠ DevP.bat -DEBUG 1>> %output%
if exist DevP.bat 		(call DevP.bat -DEBUG 1>> %output% 2>&1) else 		(echo MISSING DevP.bat 1>> %output%)
timeout /t 2 /noBreak
echo ------------------------ 1>> %output%
echo ☠ mapDisk.bat -DEBUG 1>> %output%
if exist mapDisk.bat 	(call mapDisk.bat -DEBUG 1>> %output% 2>&1) else 	(echo MISSING DevP.bat 1>> %output%) 
timeout /t 2 /noBreak
echo ------------------------ 1>> %output%
echo ☠ mapFolders.bat -DEBUG 1>> %output%
if exist mapFolders.bat (call mapFolders.bat -DEBUG 1>> %output% 2>&1) else (echo MISSING DevP.bat 1>> %output%)
popd
call:EndOfSection

::-----------------------------------
START "Arma3Tools_diag_retail" "%output%"
rem del %output% 
exit 0


::---------------------------------------------------------------------------
::	ERRORS
::---------------------------------------------------------------------------
:error
color 0c
echo /!\ Error, cannot proceed /!\
if %ERRCODE% EQU 1 echo User cancel
if %ERRCODE% EQU 1 echo User cancel 1>> %output%
if %ERRCODE% EQU 2 echo This script must be placed at the root directory of Arma 3 Tools
if %ERRCODE% EQU 2 echo This script must be placed at the root directory of Arma 3 Tools 1>> %output%
if %ERRCODE% EQU 3 echo Arma 3 Tools is not properly installed, please, reinstall it or verify the cache from Steam
if %ERRCODE% EQU 3 echo Arma 3 Tools is not properly installed, please, reinstall it or verify the cache from Steam  1>> %output%
if %ERRCODE% EQU 4 echo `Arma3Tools_diag_retail.bat` must be run from the Arma 3 Tools, not P:
if %ERRCODE% EQU 4 echo `Arma3Tools_diag_retail.bat` must be run from the Arma 3 Tools, not P:  1>> %output%
if exist "%output%" START "Arma3Tools_diag_retail" "%output%"
timeout /T 10 /noBreak
exit %ERRCODE%
exit /B


::---------------------------------------------------------------------------
::	FUNCTIONS
::---------------------------------------------------------------------------
:search_HKCR
::	Description: search the default action assign to a given file type
::	Parameter(s):
::		%1: file type to search
::	Returns:
::		Nothing
echo %1...
REG Query "HKCR\.%1" /S 1>> %output% & echo %1 [OK]
goto:eof


:BeginOfSection
::	Description: Print new title and store it to log
::	Parameter(s):
::		%0-9: Title
::	Returns:
::		Nothing
echo.
call:formatDate
echo ------------------------------------------------
echo %* [%formatedDate%] 
echo. 1>> %output%
echo ------------------------------------------------ 1>> %output%
echo %* [%formatedDate%] 1>> %output%
echo ------------------------------------------------ 1>> %output%
goto:eof

:EndOfSection
::	Description: Print new title and store it to log
::	Parameter(s):
::		%0-9: Title
::	Returns:
::		Nothing
echo.
call:formatDate
echo End of Section [%formatedDate%] 
echo ------------------------------------------------
echo ------------------------------------------------ 1>> %output%
echo End of Section [%formatedDate%] 1>> %output%
echo ------------------------------------------------ 1>> %output%
goto:eof


:formatDate
::	Description:
::		Set the real date & time
::	Parameter(s):
::	Returns:
set timeIs=%TIME::=-%
set today=%DATE:/=-%
set formatedDate=%today% %timeIs%
goto:eof


:print_time
::	Description:
::	Parameter(s):
::	Returns:
call:formatDate
echo %timeIs%
goto:eof

:getOSVersion
::	Description:
::	Parameter(s):
::		%1 Version
::		%2 Name
::	Returns:
@ver | findstr /i %1
if %ERRORLEVEL% EQU 0 (echo OS=%2 %1)
goto:eof